<?php
########################################################################
#                                                                      #
# WEBalbum                                                             #
# www.web-album.org                                                    #
# version: 2.0 EN                                                      #
# Copyright (C) 2004-2005 duda                                         #
#                                                                      #
# WEBalbum is a freeware.                                              #
# You can install and use it without any changes                       #
# for free and no limits.                                              #
#                                                                      #
########################################################################


function db_conn()
{
	return @db_connect(DB_TYPE,DB_NAME,DB_HOST,DB_USER,DB_PASSWORD);
}


function db_connect($db_type='MySQL',$db_name,$db_host,$db_user,$db_password)
{
	switch($db_type)
	{
		case 'MySQL':
			$db_connection = mysql_connect($db_host,$db_user,$db_password);
			if (!$db_connection) return 0;
			$db=mysql_select_db($db_name, $db_connection);
			if (!$db) return 1;
			return 2;
			break;
	}
}


function db_query_select($sql_query,$db_type='MySQL')
{
	$db_type=DB_TYPE;
	switch($db_type)
	{
		case 'MySQL':
			$rows = array();
			$sql_result = @mysql_query($sql_query);
			while($row = @mysql_fetch_array($sql_result)) array_push($rows, $row);
			return $rows;
			break;
	}
}


function db_query_exe($sql_query,$db_type='MySQL')
{
	$db_type=DB_TYPE;
	switch($db_type)
	{
		case 'MySQL':
			@mysql_query($sql_query);
			return mysql_errno();
			break;
	}
}


function DBExport_Struct($table,$prefix='')
{
	$struct='';
	$struct2='';
	$primary='';
	$query = "SHOW FIELDS FROM $table";
	$array=db_query_select($query);
	$table=str_replace($prefix,'!PREFIX!',$table);
	$struct.="CREATE TABLE $table (";
	foreach ($array as $tab)
	{
		if($tab["Key"]=="PRI") $primary=$tab["Field"];
		$struct2.=$tab["Field"]." ";	
		$struct2.=$tab["Type"]." ";
		$struct2.=($tab["Null"]=='YES') ? "" : "NOT NULL ";
		if($tab["Extra"]=="auto_increment")
		{
			$struct2.='auto_increment';
		}
		else
		{
			$struct2.="default ";
			$struct2.=($tab["Default"]===NULL) ? "NULL" : "'".$tab["Default"]."'";
		}
		$struct2.=', ';
	}
	if($struct2)
	{
		if ($primary) $struct2.="PRIMARY KEY ($primary)";
		$struct.=$struct2.") TYPE=MyISAM;\n";	
		return $struct;
	}
	else
		return false;
}


function DBExport_Data($table,$prefix='')
{
	$data='';
	$query = "SELECT * FROM $table";
	$array=db_query_select($query);
	$table=str_replace($prefix,'!PREFIX!',$table);
	foreach ($array as $tab)
	{
		$keys='';
		$values='';
		$data.="INSERT INTO $table (";
		foreach($tab as $key=>$value)
		{
			if(!is_int($key))
			{
				$keys.=$key.', ';
				$values.="'".addslashes($value)."', ";
			}
		}
		$data.=substr($keys,0,-2).") VALUES (";
		$data.=substr($values,0,-2).");\n";
	}
	return $data;
}


function DB_table_exist($table)
{
	$query="SHOW TABLES";
	$array=db_query_select($query);
	foreach ($array as $key)
	{
		if ($table==$key[0]) return true;
	}
	return false;
}
?>