<?php
########################################################################
#                                                                      #
# WEBalbum                                                             #
# www.web-album.org                                                    #
# version: 2.0 EN                                                      #
# Copyright (C) 2004-2005 duda                                         #
#                                                                      #
# WEBalbum is a freeware.                                              #
# You can install and use it without any changes                       #
# for free and no limits.                                              #
#                                                                      #
########################################################################


function read_file($file)
{
	if (file_exists($file))
	{
		$file_ = fopen($file, 'rb');
      $content = fread($file_, filesize($file));
      fclose($file_);
		return $content;		
	}
	else 
		return false;
}


function Censor($string)
{
	global $LA;
	$ret=$string;
	$array=explode(",", $LA["hotstuff"]);
	foreach ($array as $value)
	{
		$patterns[]='/'.trim($value).'/i';
		$replacements[]='...';
	}
	if (isset($patterns))
	{
		$ret=preg_replace($patterns, $replacements, $ret);
	}
	return $ret;	
}


function Text_cut($string, $count)
{
	if ($count<strlen($string))
	{
		$ret=substr($string,0,$count);
		$ret=substr($ret,0,strrpos($ret, " "));
		$ret=$ret.'...';
	}
	else
	{
		$ret=$string;
	}
	return $ret;
}


function word_wrap($string,$max_width,$break=' ')
{
	$ret='';
	$words=explode(" ",$string);
	foreach ($words as $word)
	{
		if (strlen($word)>$max_width)
		{
			for ($i=0; $i<=strlen($word); $i++)
			{
				$ret.=substr($word,$i,1);
				if (!(($i+1)%$max_width)) $ret.=$break;
			}
			$ret.=$break;
		}
		else
		{
			$ret.=$word.$break;
		}
	}
	return $ret;
}


function History()
{
	$URL=basename($_SERVER["REQUEST_URI"]);
	if (!isset($_SESSION['history'])) 
	{
		$_SESSION["history"][]="index.php";
	} 
	else 
	{
		if(
			count($_SESSION["history"]>=2) && 
			$_SESSION["history"][count($_SESSION["history"])-1]!=$URL && 
			!strstr($URL,"photo.php") && 
			!strstr($URL,"photo_add-b.php") && 
			!strstr($URL,"photo_add-c.php") && 
			!strstr($URL,"photo_jpg.php") && 
			!strstr($URL,"photo_del.php") && 
			!strstr($URL,"category_del.php") && 				
			!strstr($URL,"category_add-b.php") && 
			!strstr($URL,"category_moderate-b.php") && 
			!strstr($URL,"group_del.php") && 
			!strstr($URL,"group_add-b.php") && 
			!strstr($URL,"user_del.php") && 
			!strstr($URL,"user_add-b.php") && 
			!strstr($URL,"change_details-b.php") && 
			!strstr($URL,"importer-b.php") && 
			!strstr($URL,"preferences-b.php") && 
			!strstr($URL,"comment_del.php") && 
			!ereg("^id",$URL)
			)
		{
			$_SESSION["history"][]=$URL;
		}
	}
	if (count($_SESSION["history"])>20) $_SESSION["history"]=array_slice($_SESSION["history"], 10); 
}


function addslashes_d($string)
{
	if (get_magic_quotes_gpc()) 
		return $string;
	else 
		return addslashes($string);
}


function get_GET()
{
	$variables='';
	foreach($_GET as $key=>$value) 
	{
	   $variables.='$'.$key.'=$_GET["'.$key.'"];';
	}
	return $variables;
}

function get_POST()
{
	$variables='';
	foreach($_POST as $key=>$value) 
	{
	   $variables.='$'.$key.'=$_POST["'.$key.'"];';
	}
	return $variables;
}


function JS_start()
{
	$ret="<SCRIPT type='text/javascript'><!--\n";
	
	return $ret;	
}


function JS_stop()
{
	$ret="\n//--></SCRIPT>";
	return $ret;	
}


function send_Email($to,$subject,$content)
{
	$headers="MIME-Version: 1.0\n";
	$headers.="Content-type: text; charset=".SYSTEM_CHARSET."\n";
	$headers.="From: ".SYSTEM_MAIN_TITLE." <".SYSTEM_EMAIL.">\n";
	$headers.="To: <".$to.">\n";
	$headers.="X-Priority: 1\n";
	mail ($to, $subject, $content, $headers);
}


function XMLtoArray($XML)
{
	$xml_parser = xml_parser_create();
	xml_parse_into_struct($xml_parser, $XML, $vals);
	$errorcode=xml_get_error_code($xml_parser);
	if ($errorcode != XML_ERROR_NONE)
	{
		$error=xml_error_string($errorcode);
		if ($error)
		{
			exit("XML error: $error at line ".xml_get_current_line_number($xml_parser));
		}
	}
	xml_parser_free($xml_parser);
	$_tmp='';
	foreach ($vals as $xml_elem)
	{ 
		$x_tag=$xml_elem['tag'];
		$x_level=$xml_elem['level'];
		$x_type=$xml_elem['type'];
		if ($x_level!=1 && $x_type == 'close')
		{
			if (isset($multi_key[$x_tag][$x_level]))
				$multi_key[$x_tag][$x_level]=1;
			else
				$multi_key[$x_tag][$x_level]=0;
		}
		if ($x_level!=1 && $x_type == 'complete')
		{
			if ($_tmp==$x_tag) 
				$multi_key[$x_tag][$x_level]=1;
			$_tmp=$x_tag;
		}
	}
	foreach ($vals as $xml_elem)
	{ 
		$x_tag=$xml_elem['tag'];
		$x_level=$xml_elem['level'];
		$x_type=$xml_elem['type'];
		if ($x_type == 'open') 
			$level[$x_level] = $x_tag;
		$start_level = 1;
		$php_stmt = '$xml_array';
		if ($x_type=='close' && $x_level!=1) 
			$multi_key[$x_tag][$x_level]++;
		while($start_level < $x_level)
		{
  			$php_stmt .= '[$level['.$start_level.']]';
  			if (isset($multi_key[$level[$start_level]][$start_level]) && $multi_key[$level[$start_level]][$start_level]) 
  				$php_stmt .= '['.($multi_key[$level[$start_level]][$start_level]-1).']';
  			$start_level++;
		}
		$add='';
		if (isset($multi_key[$x_tag][$x_level]) && $multi_key[$x_tag][$x_level] && ($x_type=='open' || $x_type=='complete'))
		{
			if (isset($multi_key2[$x_tag][$x_level]))
				$multi_key2[$x_tag][$x_level]++;
			else
				$multi_key2[$x_tag][$x_level]=0;
		 	$add='['.$multi_key2[$x_tag][$x_level].']'; 
		}
		if (isset($xml_elem['value']) && trim($xml_elem['value'])!='' && !array_key_exists('attributes',$xml_elem))
		{
			if ($x_type == 'open') 
				$php_stmt_main=$php_stmt.'[$x_type]'.$add.'[\'content\'] = $xml_elem[\'value\'];';
			else
				$php_stmt_main=$php_stmt.'[$x_tag]'.$add.' = $xml_elem[\'value\'];';
			eval($php_stmt_main);
		}
		if (array_key_exists('attributes',$xml_elem))
		{
			if (isset($xml_elem['value']))
			{
				$php_stmt_main=$php_stmt.'[$x_tag]'.$add.'[\'content\'] = $xml_elem[\'value\'];';
				eval($php_stmt_main);
			}
			foreach ($xml_elem['attributes'] as $key=>$value)
			{
				$php_stmt_att=$php_stmt.'[$x_tag]'.$add.'[$key] = $value;';
				eval($php_stmt_att);
			}
		}
	}
 	return $xml_array;
}	
?>